#include <iterator>

/* Template-Klasse fuer Insert-Iterator
 *  - frueher statt "iterator<output_iterator_tag,void,void,void,void>"
 *          einfach "output_iterator"
 */
template <class Container>
class asso_insert_iterator
  : public iterator <output_iterator_tag, void, void, void, void>
{
  protected:
    Container& container;    // Container zum Einfuegen

  public:
    /* Konstruktor
     */
    explicit asso_insert_iterator (Container& c) : container(c) {
    }

    /* Zuweisung eines Wertes ruft insert() auf
     */
    asso_insert_iterator<Container>&
    operator= (const typename Container::value_type& value) { 
        container.insert(value);
        return *this;
    }

    /* Dereferenzierung liefert wieder Iterator
     */
    asso_insert_iterator<Container>& operator*  () {
        return *this;
    }

    /* Inkrementierung (praefix, postfix) liefert wieder Iterator
     */
    asso_insert_iterator<Container>& operator++ () {
        return *this;
    }
    asso_insert_iterator<Container>& operator++ (int) {
        return *this;
    }
};

/* Inserter dazu
 */
template <class Container>
inline asso_insert_iterator<Container> asso_inserter (Container& c)
{
    return asso_insert_iterator<Container>(c);
}
